//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "dirichlet.h"
#include "sinusprod.h"
using namespace std;
int main() {
  mesh<double,2> Th;
  cin >> Th;
  valarray<double> uh = dirichlet (Th, interpolate (Th, f));
  valarray<double> pi_h_u = interpolate (Th, u);
  valarray<double> err = abs(pi_h_u-uh);
  cerr << "err " << err.max() << endl;
}
