//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "fft.h"
#include "valarray_io.h"
#include <complex>
#include <iostream>
#include <iomanip>
#include <cassert>
using namespace std;
int main() {
  valarray<complex<double> > x;
  cin >> x;
  size_t n = x.size();
  assert(fabs(log2(n)-int(log2(n))) < 1e-10);
  const double pi = acos(-1.0);
  const complex<double> i (0,1);
  complex<double> w  = exp((2*pi/n)*i);
  valarray<complex<double> > y(n);
  fft (1./w, x, y);
  cout << setprecision(16) << y;
}
