//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#define MATRIX_VERSION 2

#if (MATRIX_VERSION >= 2)
#include "matrix_class_v2_m4.icc"
#else
#include "matrix_class_m4.icc"
#endif

#include "matrix_cstor.icc"
#include "matrix_io1.icc"
#include "matrix_io2.icc"
#include "matrix_amulx.icc"

#if (MATRIX_VERSION >= 2)
#include "matrix_inplace_left_mult.icc"
#include "matrix_inplace_right_mult.icc"
#include "matrix_gnuplot.icc"
#endif

#if (MATRIX_VERSION >= 3)
#include "matrix_accessors.icc"
#include "matrix_check.icc"
#include "matrix_frobenius.icc"
#include "matrix_average_dist_diag.icc"
#include "matrix_diagonal_dominant.icc"
#include "matrix_diag.icc"
#include "matrix_inplace_add_diag.icc"
#include "matrix_tril.icc"
#include "matrix_trans_mult.icc"
#endif

#include "matrix_coef.icc"
#include "matrix_entry.icc"
#include "matrix_cstor_struct.icc"
