//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "mesh_gdat.h"
#include <fstream>
using namespace std;
int main(int argc, char**argv) {
  if (argc <= 1) return 0;
  mesh<double,2> Th;
  ifstream in(argv[1]);
  in >> Th;
  ofstream gdat("tmp.gdat");
  mesh_gdat (gdat, Th);
  gdat.close ();
  ofstream plot ("tmp.plot");
  plot << "set size ratio 1" << endl
       << "plot 'tmp.gdat' notitle with lines" << endl
       << "pause -1 '<retour>'" << endl;
  plot.close();
  system("gnuplot tmp.plot");
  system("rm -f tmp.plot tmp.gdat");
}
