//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "mesh.h"
template <typename T>
void mesh_gdat (std::ostream& gdat, const mesh<T,2>& Th) {
  using namespace std;
  for (size_t e = 0; e < Th.size(); e++) {
    const point<T,2>& a = Th.vertex (Th[e][0]),
                      b = Th.vertex (Th[e][1]),
                      c = Th.vertex (Th[e][2]);
    gdat << a[0] << " " << a[1] << endl
	 << b[0] << " " << b[1] << endl
	 << c[0] << " " << c[1] << endl
	 << c[0] << " " << c[1] << endl
	 << a[0] << " " << a[1] << endl << endl;
  }
}
