//
// This file is part of the book "Language C++ et calcul scientifique"
//
// Copyright (C) 2005-2012 Pierre Saramito <Pierre.Saramito@imag.fr>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
const double pi = acos(double(-1));
template <size_t D>
double u (const point<double,D>& x) {
  double value = 1;
  for (size_t i = 0; i < D; ++i) 
    value *= sin(pi*x[i]);
  return value;
}
template <size_t D>
double f (const point<double,D>& x) {
  return D*pi*pi*u(x);
}
